// Gutierrez, Cesareo
// cgutie@essex.ac.uk
// CC484 Assignment.December 2002

import java.lang.*;

/**
 * This class is used as a tool for encapsulating integer data. It is composed
 * of an integer array and an index. The index is used to read it properly.
 *
 * @version 1.0 10/12/2002
 * @author Cesareo Gutierrez
 */
public class MyArray implements Cloneable{

  /** It says if the initial values will be random or not **/
  static boolean RANDOM = false;

  /** The data **/
  int[] m_values;
  public int length;
  /** It helps to read easily the data. It is also useful for cloning **/
  int m_index;

  /**
  * Constructor
  * It sets up the initial values.
  */
  public MyArray(int dimension) {
    m_values = new int[dimension];
    length = dimension;
    m_index = 0;
    for (int i = 0; i < dimension; i++) {
      m_values[i] = i;
    }
    //If we want random initial values. We just change the position of the
    //actual values.
    int times = 200;
    if (RANDOM){
      while(times-- != 0){
        int index1,index2,temp;
        //It takes two random indexes of the array
        index1 = (int)(Math.random()*((double)dimension-1.0));
        index2 = (int)(Math.random()*((double)dimension-1.0));
        //Their values are interchanged
        temp = m_values[index1];
        m_values[index1] = m_values[index2];
        m_values[index2] = temp;
      }

    }

  }

  /**
  * pickValue
  * It returns the next value in the array .
  *
  * @return the next value in the array
  */
  public int pickValue(){
    return m_values[m_index++];
  }

  /**
  * isEmpty
  * It returns if we have already read it all or not.
  *
  * @return if we have already read it all or not
  */
  public boolean isEmpty(){
    return (m_index == m_values.length);
  }

  /**
  * clone
  * It ensures that the algorithm has unique local variables.
  *
  * @return a clone of the actual object.
  */
  public Object clone(){
    Object obj=null;
    try {
      obj =  super.clone();
    }catch (Exception ex) {
      ex.printStackTrace();
    }
    return obj;
  }
}